/*************************************************************************************************
** Project:     FSMGenerator
** Package:     FSMApi
** Module:      FSMApi::Java
** File:        AbstractFSM.java
** Date:        2002.08.01
** Author:      Pavel Bekkerman (chpavel@tx.technion.ac.il)
** Copyright:   Copyright (C) 2002 Pavel Bekkerman
** License:
**              This program is free software; you can redistribute it and/or
**              modify it under the terms of the GNU General Public License as
**              published by the Free Software Foundation; either version 2 of
**              the License, or (at your option) any later version.
**
**              This program is distributed in the hope that it will be useful,
**              but WITHOUT ANY WARRANTY; without even the implied warranty of
**              MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**              GNU General Public License for more details.
**
**              You should have received a copy of the GNU General Public License
**              along with this program; if not, write to the Free Software
**              Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
** Contact:     Pavel Bekkerman (chpavel@tx.technion.ac.il)
*************************************************************************************************/

package FSMApi;

// API
public interface AbstractFSM
{
  public int _getStartState() throws FSMException;
  public FSMIDPair _getNextIncarnation( int idState, int idEvent ) throws FSMException;
  public boolean _isFinalState    ( int idState ) throws FSMException;
  public void _processStateEnter  ( int isState ) throws FSMException;
  public void _processStateExit   ( int isState ) throws FSMException;
  public void _processEvent       ( int idEvent ) throws FSMException;
  public void _processCallback    ( int idCallback ) throws FSMException;
  public void _processTransition  ( int idTransition ) throws FSMException;
}
