/************************************************************************************************
** Project:     FSMGenerator
** Module:	FSMGenerator::examples::Cpp
** File:	main_FSMIsEven.cpp
** Date:        2002.08.01
** Author:      Pavel Bekkerman (chpavel@tx.technion.ac.il)
** Copyright:   Copyright (C) 2002 Pavel Bekkerman
** License:
**             This program is free software; you can redistribute it and/or
**             modify it under the terms of the GNU General Public License as
**             published by the Free Software Foundation; either version 2 of
**             the License, or (at your option) any later version.
**
**             This program is distributed in the hope that it will be useful,
**             but WITHOUT ANY WARRANTY; without even the implied warranty of
**             MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**             GNU General Public License for more details.
**
**             You should have received a copy of the GNU General Public License
**             along with this program; if not, write to the Free Software
**             Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
** Contact:     Pavel Bekkerman (chpavel@tx.technion.ac.il)
************************************************************************************************/

#include <iostream>

#include "main_FSMIsEven.h"
#include "FSMApi.h"
#include "FSMIsEven.h"

using namespace std;
using namespace FSMApi;

int main()
{
	AbstractFSM *pTestedFSM = new FSMIsEven::FSMIsEven();
	FSM *pFSM = new FSM( *pTestedFSM );

    try
    {
      pFSM->Initialize();
      pFSM->Process( FSMIsEven::EVENT_input0 );
      pFSM->Process( FSMIsEven::EVENT_input1 );
      pFSM->Process( FSMIsEven::EVENT_input0 );
      pFSM->Process( FSMIsEven::EVENT_input1 );
      pFSM->Process( FSMIsEven::EVENT_input0 );
      pFSM->Process( FSMIsEven::EVENT_input1 );
      
      if( pFSM->IsFinal() )
      {
        cout << "Final"  << endl;
      }

      else
      {
        cout << "NonFinal" << endl;
      }

      pFSM->Finalize();
    }
    catch( FSMException& e )
    {
      cout << e.what() << endl;
    }

	delete pFSM;
	delete pTestedFSM;

	return 1;
}

void Func0()
{
	cout << "in Func0" << endl;
}

void Func1()
{
	cout << "in Func1" << endl;
}

void Func2()
{
	cout << "in Func2" << endl;
}

void Func3()
{
	cout << "in Func3" << endl;
}

