/*************************************************************************************************
** Project:     FSMGenerator
** Package:     FSMGenerator
** Module:      FSMGenerator::db
** File:        FSMCallback.cpp
** Date:        2002.08.01
** Author:      Pavel Bekkerman (chpavel@tx.technion.ac.il)
** Copyright:   Copyright (C) 2002 Pavel Bekkerman
** License:
**              This program is free software; you can redistribute it and/or
**              modify it under the terms of the GNU General Public License as
**              published by the Free Software Foundation; either version 2 of
**              the License, or (at your option) any later version.
**
**              This program is distributed in the hope that it will be useful,
**              but WITHOUT ANY WARRANTY; without even the implied warranty of
**              MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**              GNU General Public License for more details.
**
**              You should have received a copy of the GNU General Public License
**              along with this program; if not, write to the Free Software
**              Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
** Contact:     Pavel Bekkerman (chpavel@tx.technion.ac.il)
*************************************************************************************************/

#include "FSMCallback.h"

//********************************************************* Callback Functions

//******************** Constructor

FSMGenerator::Callback::Callback(const string& strName, ID id, const string& strFunc)
		: m_strName(strName), m_id(id), m_strFunction(strFunc)
{
}

//******************** Destructor

FSMGenerator::Callback::~Callback()
{
}

//******************** Name

const string&
FSMGenerator::Callback::Name()const 
{
	return m_strName;
}

//******************** GetID

ID
FSMGenerator::Callback::GetID()const 
{
	return m_id;
}

//******************** Function

const string&
FSMGenerator::Callback::Function()const 
{
	return m_strFunction;
}

//******************** SetFunction

void
FSMGenerator::Callback::SetFunction(const string& strFunc)
{
	m_strFunction = strFunc;
}
