/*************************************************************************************************
** Project:     FSMGenerator
** Package:     FSMGenerator
** Module:      FSMGenerator::db
** File:        FSMDB.h
** Date:        2002.08.01
** Author:      Pavel Bekkerman (chpavel@tx.technion.ac.il)
** Copyright:   Copyright (C) 2002 Pavel Bekkerman
** License:
**              This program is free software; you can redistribute it and/or
**              modify it under the terms of the GNU General Public License as
**              published by the Free Software Foundation; either version 2 of
**              the License, or (at your option) any later version.
**
**              This program is distributed in the hope that it will be useful,
**              but WITHOUT ANY WARRANTY; without even the implied warranty of
**              MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**              GNU General Public License for more details.
**
**              You should have received a copy of the GNU General Public License
**              along with this program; if not, write to the Free Software
**              Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
** Contact:     Pavel Bekkerman (chpavel@tx.technion.ac.il)
*************************************************************************************************/

#ifndef _FSMDB_
#define _FSMDB_

#pragma warning (disable : 4786)

#include "../FSMGlobals.h"
#include "FSMState.h"
#include "FSMEvent.h"
#include "FSMTransition.h"
#include "FSMCallback.h"

#include <vector>

using std::vector;

//************************************************* FSMDB
namespace FSMGenerator
{

	struct FSMDB
	{
		
			FSMDB(const string& name = STRNULL);
			~FSMDB();

			string m_strName;	// the FSM name.
			const string& Name	()const;

			// Data holders (can be read directly by the file generators).
			vector<State>		m_dvStates;
			vector<Event>		m_dvEvents;
			vector<Transition>	m_dvTransitions;	
			vector<Callback>	m_dvCallbacks;

			vector<ID>			m_dvFinalID;
			INDEX				m_indStart;

	};

}

#endif // _FSMDB_

