/*************************************************************************************************
** Project:     FSMGenerator
** Package:     FSMGenerator
** Module:      FSMGenerator::db
** File:        FSMDBException.h
** Date:        2002.08.01
** Author:      Pavel Bekkerman (chpavel@tx.technion.ac.il)
** Copyright:   Copyright (C) 2002 Pavel Bekkerman
** License:
**              This program is free software; you can redistribute it and/or
**              modify it under the terms of the GNU General Public License as
**              published by the Free Software Foundation; either version 2 of
**              the License, or (at your option) any later version.
**
**              This program is distributed in the hope that it will be useful,
**              but WITHOUT ANY WARRANTY; without even the implied warranty of
**              MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**              GNU General Public License for more details.
**
**              You should have received a copy of the GNU General Public License
**              along with this program; if not, write to the Free Software
**              Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
** Contact:     Pavel Bekkerman (chpavel@tx.technion.ac.il)
*************************************************************************************************/

#ifndef _FSMDBEXCEPTION_
#define _FSMDBEXCEPTION_

#include <string>
using std::string;


namespace FSMGenerator
{

//************************************************* DBException
	class DBException
	{
		const int	 m_nErrNumber;
		const string m_strErrInfo;

	public:

	enum {
			   UndefinedName,
			   DuplicatedNames,
			   DuplicatedEventHandler,
			   DuplicatedStartState,
			   DuplicatedHook,
			   IllegalCallbackName,
			   IllegalFunctionName,
			   WrongNumberOfHooks
		};

		DBException(int, const string& = "");
		~DBException();

		int				ErrorNumber	() const;
		const string&	ErrorInfo	() const;
	};

}




#endif

