/*************************************************************************************************
** Project:	FSMGenerator
** Package:     FSMGenerator
** Module:	FSMGenerator::db
** File:        FSMEvent.cpp
** Date:        2002.08.01
** Author:      Pavel Bekkerman (chpavel@tx.technion.ac.il)
** Copyright:   Copyright (C) 2002 Pavel Bekkerman
** License:
**              This program is free software; you can redistribute it and/or
**              modify it under the terms of the GNU General Public License as
**              published by the Free Software Foundation; either version 2 of
**              the License, or (at your option) any later version.
**
**              This program is distributed in the hope that it will be useful,
**              but WITHOUT ANY WARRANTY; without even the implied warranty of
**              MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**              GNU General Public License for more details.
**
**              You should have received a copy of the GNU General Public License
**              along with this program; if not, write to the Free Software
**              Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
** Contact:     Pavel Bekkerman (chpavel@tx.technion.ac.il)
*************************************************************************************************/

#include "FSMEvent.h"

//********************************************************* Event Functions

//******************** Constructor

FSMGenerator::Event::Event(const string& strName, ID id)
	: m_strName(strName), m_id(id), m_indCallback(NULL_INDEX)
{
}

//******************** Destructor

FSMGenerator::Event::~Event()
{
}

//******************** Name

const string&
FSMGenerator::Event::Name()const 
{
	return m_strName;
}

//******************** GetID

ID
FSMGenerator::Event::GetID()const 
{
	return m_id;
}

//******************** Callback
INDEX
FSMGenerator::Event::Callback ()const 
{
	return m_indCallback;
}

//******************** SetCallback

void
FSMGenerator::Event::SetCallback(INDEX indCall)
{
	if(m_indCallback != NULL_INDEX)
		throw string("Error: Callback was already attached to '"+m_strName+"' event.");

	m_indCallback = indCall;
}



