/*************************************************************************************************
** Project:     FSMGenerator
** Package:     FSMGenerator
** Module:      FSMGenerator::db
** File:        FSMiTransition.h
** Date:        2002.08.01
** Author:      Pavel Bekkerman (chpavel@tx.technion.ac.il)
** Copyright:   Copyright (C) 2002 Pavel Bekkerman
** License:
**              This program is free software; you can redistribute it and/or
**              modify it under the terms of the GNU General Public License as
**              published by the Free Software Foundation; either version 2 of
**              the License, or (at your option) any later version.
**
**              This program is distributed in the hope that it will be useful,
**              but WITHOUT ANY WARRANTY; without even the implied warranty of
**              MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**              GNU General Public License for more details.
**
**              You should have received a copy of the GNU General Public License
**              along with this program; if not, write to the Free Software
**              Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
** Contact:     Pavel Bekkerman (chpavel@tx.technion.ac.il)
*************************************************************************************************/

#ifndef _FSMTRANSITION_
#define _FSMTRANSITION_

#include "../FSMGlobals.h"

namespace FSMGenerator
{

//************************************************* Transition
	class Transition
	{
		public:
			Transition(const string&,ID,INDEX,INDEX,INDEX,INDEX=NULL_INDEX);				
			~Transition();

			// set
			void  SetCallback (INDEX);

			// get
			const string& Name		  ()const ;
			ID			  GetID		  ()const ;
			INDEX		  FromState	  ()const ;
			INDEX		  WithEvent	  ()const ;
			INDEX		  ToState	  ()const ;
			INDEX		  Callback	  ()const ;

		private:
			ID	   m_id;
			string m_strName;

			INDEX  m_indFromState,
				   m_indWithEvent,
				   m_indToState;

			INDEX  m_indCallback;

	};

}








#endif
