/*************************************************************************************************
** Project:     FSMGenerator
** Package:     FSMGenerator
** Module:      FSMGenerator::generator
** File:        FSMFileGenerator.h
** Date:        2002.08.01
** Author:      Pavel Bekkerman (chpavel@tx.technion.ac.il)
** Copyright:   Copyright (C) 2002 Pavel Bekkerman
** License:
**              This program is free software; you can redistribute it and/or
**              modify it under the terms of the GNU General Public License as
**              published by the Free Software Foundation; either version 2 of
**              the License, or (at your option) any later version.
**
**              This program is distributed in the hope that it will be useful,
**              but WITHOUT ANY WARRANTY; without even the implied warranty of
**              MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**              GNU General Public License for more details.
**
**              You should have received a copy of the GNU General Public License
**              along with this program; if not, write to the Free Software
**              Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
** Contact:     Pavel Bekkerman (chpavel@tx.technion.ac.il)
*************************************************************************************************/

#ifndef _FSMFILEGENERATOR_
#define _FSMFILEGENERATOR_

#include "../db/FSMDB.h"

#include <string>
using std::string;

namespace FSMGenerator
{

// ****************************************************** FSMFileGenerator

	class FSMFileGenerator
	{
	protected:
		const FSMDB& m_fsmDb;
		string		 m_strDestinationPath;

		virtual bool _stateFileGenerator()const = 0;
		virtual bool _eventFileGenerator()const = 0;
		virtual bool _transFileGenerator()const = 0;
		virtual bool _callsFileGenerator()const = 0;
		virtual bool _mainFileGenerator ()const = 0;
			int  _directoryCreate();

	public:
		FSMFileGenerator(const FSMDB&, const string& strPath);
		virtual ~FSMFileGenerator();

		bool GenerateFiles();
	};

}

#endif
